//      "" 
//     FillMatrix 
//   Gauss      

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include "in.cpp"

const int MAX = 10000;					//   
void FillMatrix (double**, int);		//   
void Gauss (double**, double*, int);	//  
int in (int, int);

void main()
{
	int i, n;
	double **a, *x;
	puts ("\n  System order ?\n");
	n = in (2,MAX);			//     (2, MAX)

	x = new double[n];		//    
	a = new double*[n];		//   
	for (i=0; i<n; i++)		//  
		a[i] = new double[n+1];

	FillMatrix (a, n);		//  
	Gauss (a, x, n);		//   
	puts ("\n\n\tSolution\n\n");
	for (i=0; i<n; i++)
		printf ("%7.2f",x[i]);
	puts("\n\n");
}

void FillMatrix (double **a, int n)
{		//   
	int i, j;
	for (i=0; i<n; i++)				// "" 
		for (j=0; j<n; j++)
			a[i][j] = sin((i+j+.2)/20.)+log(i+j+1.);

		for (i=0; i<n; i++)			//   
			for (j=0, a[i][n]=0.; j<n; j++)
				a[i][n] += a[i][j]*j;

		for (i=0; i<n; i++)
		{							//   
			putch('\n');
			for (j=0; j<n+1; j++)
				printf ("%7.2f",a[i][j]);
		}
}

void Gauss (double **a,		//  
			double *x,		//  
			int n)			//  
{				//====     ====//
	double c, s, d;
	int i, j, k;
				//  
	for (k=0; (d=a[k][k])!=0. && k<n-1; k++)
		for (i=k+1; i<n; i++)
			for (c=a[i][k]/d, j=k+1; j<n+1; j++)
				a[i][j] -= c*a[k][j];

	if (!d)
	{						//=====  
		printf ("\n\nZero Pivot at line %d",k+1);
		exit(0);
	}

	for (k=n-1; k>=0; --k)
	{						//===  
		for (s=0., j=n-1; j>k; --j)
			s += a[k][j]*x[j];
		x[k]=(a[k][n]-s)/a[k][k];
	}
}
